static class Tile{

  public final int BONUS_CACAO = 1;
  public final int BONUS_INDIGO = 2;
  public final int BONUS_CHERRY = 3;
  public final int BONUS_COPPER = 4;
  public final int BONUS_GUINEAPIG = 5;

  public final int EXTRA_TENT = 1;
  public final int EXTRA_RUIN = 2;

  public final int FOE_NOMAD = 1;
  public final int FOE_TIGER = 2;
  public final int FOE_WOLF = 3;
  public final int FOE_MALARIA = 4;

  static boolean loaded = false;
  static PImage BONUS_CACAO_I;
  static PImage BONUS_INDIGO_I;
  static PImage BONUS_CHERRY_I;
  static PImage BONUS_COPPER_I;
  static PImage BONUS_GUINEAPIG_I;

  static PImage EXTRA_TENT_I; 
  static PImage EXTRA_RUIN_I; 

  static PImage FOE_NOMAD_I; 
  static PImage  FOE_TIGER_I; 
  static PImage  FOE_WOLF_I; 
  static PImage  FOE_MALARIA_I; 

  boolean visited = false;
  boolean visible = false;
  PImage bkgI;
  PImage bonusI = null;
  PImage extraI = null;
  PImage foeI = null;
  int foe = -1;
  int extra = -1;
  int bonus = -1;

  public Tile(PApplet proc, PImage bkg){
    this.bkgI = bkg;
    if (!loaded) {
      BONUS_CACAO_I = proc.loadImage("cacao.png");
      BONUS_INDIGO_I = proc.loadImage("indigo.png");
      BONUS_CHERRY_I = proc.loadImage("cherry.png");
      BONUS_COPPER_I = proc.loadImage("copper.png");
      BONUS_GUINEAPIG_I = proc.loadImage("guineapig.png");

      EXTRA_TENT_I = proc.loadImage("tent.png");
      EXTRA_RUIN_I = proc.loadImage("ruin.png");

      FOE_NOMAD_I = proc.loadImage("nomad.png");
      FOE_TIGER_I = proc.loadImage("tiger.png");
      FOE_WOLF_I = proc.loadImage("wolf.png");
      FOE_MALARIA_I = proc.loadImage("malaria.png");
      
      
      loaded = true;
    }
  }

  public PImage getBkg(){
    return this.bkgI;
  }  
  
  public boolean isVisited(){
    return this.visited;
  }
  
  public void setVisited(boolean visited){
    this.visited = visited;
  }
  
  public boolean isObservable(){
    return this.visible;
  }
  
  public void setObservable(boolean visible){
    this.visible = visible;
  }

  public void setBonus(int i){
    if(i > 0 && i <= 5){
      this.bonus = i;
    }
  }

  public void setExtra(int i){
    if(i > 0 && i <= 2){
      this.extra = i;
    }
  }

  public void setFoe(int i){
    if(i > 0 && i <= 4){
      this.foe = i;
    }
  }

  public PImage getBonusImage(){
    if(bonus == 1){
      return BONUS_CACAO_I;
    }
    else if(bonus == 2){
      return BONUS_INDIGO_I;
    }
    else if(bonus == 3){
      return BONUS_CHERRY_I;
    }
    else if(bonus == 4){
      return BONUS_COPPER_I;
    }
    else if(bonus == 5){
      return BONUS_GUINEAPIG_I;
    }
    else{
      return null;
    }
  }

  public PImage getExtraImage(){
    if(extra == 1){
      return EXTRA_TENT_I;
    }
    else if(extra == 2){
      return EXTRA_RUIN_I;
    }
    else{
      return null;
    }
  }

  public PImage getFoeImage(){
    if(foe == 1){
      return FOE_NOMAD_I;
    }
    else if(foe == 2){
      return FOE_TIGER_I;
    }
    else if(foe == 3){
      return FOE_WOLF_I;
    }
    else if(foe == 4){
      return FOE_MALARIA_I;
    }
    else{
      return null;
    }
  }


  public void fireActions(scouting_only p, Player player){ 
        
    if(this.extra == 1){
      int g = (int)p.random(10, 200);
      p.setLogText("You found " + g +" gold from the tent");
      player.setGold(player.getGold() + g);
      this.extra = -1;
      p.getPlayerGold().trigger();
    }
    if(this.extra == 2){
      int h = (int)p.random(0, 50);
      p.setLogText("You found fountain of youth");
      player.setHealth(player.getHealth() + h);
      this.extra = -1;
      p.getPlayerHealth().trigger();
    }
    if(this.bonus == 1){
      int g = (int)p.random(0, 40);
      p.setLogText("You found abundance of cacao beans");
      player.setGold(player.getGold() + g);
      this.bonus = -1;
      p.getPlayerBonus().trigger();
    }
    if(this.bonus == 2){
      int g = (int)p.random(0, 50);
      p.setLogText("You found abundance of indigo dye");
      player.setGold(player.getGold() + g);
      this.bonus = -1;
      p.getPlayerBonus().trigger();
    }
    if(this.bonus == 3){
      int g = (int)p.random(40, 60);
      p.setLogText("You found abundance of cherries");
      player.setGold(player.getGold() + g);
      this.bonus = -1;
      p.getPlayerBonus().trigger();
    }
    if(this.bonus == 4){
      int g = (int)p.random(0, 100);
      p.setLogText("You found abundance of copper");
      player.setGold(player.getGold() + g);
      this.bonus = -1;
      p.getPlayerBonus().trigger();
    }
    if(this.bonus == 5){
      int g = (int)p.random(50, 800);
      p.setLogText("You found abundance of guinea pigs");
      player.setGold(player.getGold() + g);
      this.bonus = -1;
      p.getPlayerBonus().trigger();
    }
    if(this.foe == 1){
      int h = (int)p.random(0, 20);
      p.setLogText("You found violent and fierce nomads");
      player.setHealth(player.getHealth() - h);
      p.getPlayerHurt().trigger();
    }
    if(this.foe == 2){
      int h = (int)p.random(0, 30);
      p.setLogText("You found a tiger hungry for flesh");
      player.setHealth(player.getHealth() - h);
      p.getPlayerHurt().trigger();
    }
    if(this.foe == 3){
      int h = (int)p.random(5, 20);
      p.setLogText("You found howling wolves");
      player.setHealth(player.getHealth() - h);
      p.getPlayerHurt().trigger();
    }
    if(this.foe == 4){
      int h = (int)p.random(10, 20);
      p.setLogText("You found a pest of malaria");
      player.setHealth(player.getHealth() - h);
      p.getPlayerHurt().trigger();
    }
  }
}


